Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Gems support Estimated time: 0.00 hour

Target version: 5.0.9   

Description

== Version 3.3.0

Use BasicObject instead of BlankSlate for better compatibility with modern rubies. https://github.com/rails/builder/pull/15

unfortunately, this change breaks Redmine's API. LoadError: cannot load such file -- blankslate

the following patch removes that dependency in favor of BasicObject

diff --git a/lib/redmine/views/builders/json.rb b/lib/redmine/views/builders/json.rb

index 47ce0cc9b..011c16e58 100644

--- a/lib/redmine/views/builders/json.rb

+++ b/lib/redmine/views/builders/json.rb

@@ -28,7 +28,7 @@ module Redmine

         def initialize(request, response)

           super

           callback = request.params[:callback] || request.params[:jsonp]

-          if callback && Setting.jsonp_enabled?

+          if callback && ::Setting.jsonp_enabled?

             self.jsonp = callback.to_s.gsub(/[^a-zA-Z0-9_.]/, '')

           end

         end

diff --git a/lib/redmine/views/builders/structure.rb b/lib/redmine/views/builders/structure.rb

index f4524143f..ab1e3e411 100644

--- a/lib/redmine/views/builders/structure.rb

+++ b/lib/redmine/views/builders/structure.rb

@@ -17,12 +17,10 @@

 # along with this program; if not, write to the Free Software

 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

-require 'blankslate'

-

 module Redmine

   module Views

     module Builders

-      class Structure < BlankSlate

+      class Structure < BasicObject

         def initialize(request, response)

           @struct = [{}]

           @request = request

@@ -38,7 +36,7 @@ module Redmine

         end

         def encode_value(value)

-          if value.is_a?(Time)

+          if value.is_a?(::Time)

             # Rails uses a global setting to format JSON times

             # Don't rely on it for the API as it could have been changed

             value.xmlschema(0)

@@ -49,15 +47,15 @@ module Redmine

         def method_missing(sym, *args, &block)
           if args.count > 0

-            if args.first.is_a?(Hash)

-              if @struct.last.is_a?(Array)

+            if args.first.is_a?(::Hash)

+              if @struct.last.is_a?(::Array)

                 @struct.last << args.first unless block

               else

                 @struct.last[sym] = args.first

               end

             else

               value = encode_value(args.first)

-              if @struct.last.is_a?(Array)

+              if @struct.last.is_a?(::Array)

                 if args.size == 1 && !block

                   @struct.last << value

                 else

@@ -69,13 +67,13 @@ module Redmine

             end

           end

           if block

-            @struct << (args.first.is_a?(Hash) ? args.first : {})

+            @struct << (args.first.is_a?(::Hash) ? args.first : {})

             yield(self)

             ret = @struct.pop

-            if @struct.last.is_a?(Array)

+            if @struct.last.is_a?(::Array)

               @struct.last << ret

             else

-              if @struct.last.has_key?(sym) && @struct.last[sym].is_a?(Hash)

+              if @struct.last.has_key?(sym) && @struct.last[sym].is_a?(::Hash)

                 @struct.last[sym].merge! ret

               else

                 @struct.last[sym] = ret

Related issues:

Has duplicate Redmine - Defect #40921: JSON API causes 500 Internal Server Error Closed

Associated revisions

Revision 22863 - 2024-06-07 06:47 - Go MAEDA

Replace BlankSlate with BasicObject for Builder 3.0.0 compatibility (#40802).

Patch by Pavel Rosický (@ahorek).

Revision 22864 - 2024-06-08 09:31 - Go MAEDA

Merged r22863 from trunk to 5.1-stable (#40802).

Revision 22865 - 2024-06-08 09:33 - Go MAEDA

Merged r22863 from trunk to 5.0-stable (#40802).

History

#1 - 2024-06-07 03:19 - Go MAEDA

- Target version set to 5.0.9

Setting the target version to 5.0.9.

#2 - 2024-06-07 05:29 - salman mp

Not only redmine APIs; It also breaks Redmine web app (redmine v4.2.11).

Thanks for given patch.

#3 - 2024-06-07 06:48 - Go MAEDA

- Subject changed from support builder 3.3.0 to Support builder 3.3.0

- Status changed from New to Resolved
- Assignee set to Go MAEDA

Committed the patch in r22863. Thank you.

#4 - 2024-06-07 10:45 - Brice Beaumesnil

Hello,

This problem is on 5.1-stable branche too

Thanks.

#5 - 2024-06-07 11:00 - Go MAEDA

In the 5.0-stable branch, the test hangs if the patch is applied.

It can be reproduced by running ruby test/integration/api_test/memberships_test.rb. In the test/log, SystemStackError was recorded.

SystemStackError (stack level too deep):

lib/redmine/views/builders/structure.rb:69:in `method_missing'

lib/redmine/views/builders/structure.rb:69:in `method_missing'

lib/redmine/views/builders/structure.rb:69:in `method_missing'

lib/redmine/views/builders/structure.rb:69:in `method_missing'

lib/redmine/views/builders/structure.rb:69:in `method_missing'

.

.

.

lib/redmine/views/builders/structure.rb:69:in `method_missing'

lib/redmine/views/builders/structure.rb:69:in `method_missing'

lib/redmine/views/builders/structure.rb:69:in `method_missing'

lib/redmine/views/builders/structure.rb:69:in `method_missing'

lib/redmine/views/builders/structure.rb:69:in `method_missing'

app/views/members/index.api.rsb:3

app/views/members/index.api.rsb:2:in `each'

app/views/members/index.api.rsb:2

lib/redmine/views/builders/structure.rb:32:in `array'

app/views/members/index.api.rsb:1

lib/redmine/views/builders.rb:38:in `for'

app/views/members/index.api.rsb:1

lib/redmine/sudo_mode.rb:61:in `sudo_mode'

test/integration/api_test/memberships_test.rb:37:in `block in <class:MembershipsTest>'

 For 5.1-stable and 5.0-stable, is it better to pin the version of builder to 3.2 than merge the patch?

#6 - 2024-06-07 11:04 - Brice Beaumesnil

Hello

In this patch the line "require 'blankslate'" can be deleted

Thanks.

#7 - 2024-06-07 11:16 - Brice Beaumesnil

Go MAEDA wrote in #note-5:

In the 5.0-stable branch, the test hangs if the patch is applied.

It can be reproduced by running ruby test/integration/api_test/memberships_test.rb. In the test/log, SystemStackError was recorded.

[...]

For 5.1-stable and 5.0-stable, is it better to pin the version of builder to 3.2 than merge the patch?

 I try this test with success on 5.1-stable branch

Finished in 2.357875s, 5.5134 runs/s, 19.9332 assertions/s.

13 runs, 47 assertions, 0 failures, 0 errors, 0 skips

#8 - 2024-06-07 12:56 - Pavel Rosický

@go_maeda the BasicObject doesn't know the method block_given? see https://ruby-doc.org/core-2.7.1/BasicObject.html so it falls under

method_missing, causing an infinite loop...
this can be fixed by replacing it with "::Kernel.block_given?" or a simple "block"

#9 - 2024-06-08 09:37 - Go MAEDA

- Status changed from Resolved to Closed

Pavel Rosický wrote in #note-8:

@go_maeda the BasicObject doesn't know the method block_given? see https://ruby-doc.org/core-2.7.1/BasicObject.html so it falls under

method_missing, causing an infinite loop...

this can be fixed by replacing it with "::Kernel.block_given?" or a simple "block"

 Thank you for debugging the issue, the block_given? was replaced with block in r22027 but the 5.0-stable branch still uses it. This is the reason why

the infinite loop happens in the 5.0-stable.

I have merged the fix to the stable branches.

#10 - 2024-06-18 11:03 - Vincent Robert

I don't know how, but Redmine 4.2 seems impacted by this change. All our automated tests under Redmine 4 are now failing with this error message:

Run bundle exec rake db:create db:migrate

rake aborted!

LoadError: cannot load such file -- blankslate

/redmine/lib/redmine/views/builders/structure.rb:20:in `<top (required)>'

/redmine/lib/redmine/views/builders/json.rb:20:in `<top (required)>'

/redmine/lib/redmine/views/builders.rb:20:in `<top (required)>'

/redmine/lib/redmine.rb:64:in `<top (required)>'

/redmine/config/initializers/30-redmine.rb:7:in `<top (required)>'

#11 - 2024-06-18 11:08 - Go MAEDA

Redmine 4.2 is no longer supported but you can fix the error by adding the following line to Gemfile.local.

gem 'builder', '~> 3.2.4'

#12 - 2024-06-21 17:31 - Jonathan Cormier

Go MAEDA wrote in #note-11:

Redmine 4.2 is no longer supported but you can fix the error by adding the following line to Gemfile.local.

[...]

 Thanks

#13 - 2024-07-03 15:01 - Holger Just

- Has duplicate Defect #40921: JSON API causes 500 Internal Server Error added
